# Mohammad Salmani
# Project 1

import numpy as np
import matplotlib.pyplot as plt

print('Which transformation do you want to use ?(Enter the number)')
temp= int(input('1.Conformal   2.Affine  3.projective  4.polynomial --> '))

from PIL import Image
im = Image.open('21_60.tif')
im1 = np.array(im)

plt.imshow(im1, cmap='gray')
fid = np.array(plt.ginput(8))
plt.close()
x1 = fid[:, 0]
y1 = fid[:, 1]

# Getting the number of check and Control Points
nControlPoint = int(input('How many control points should be used ? '))
nCheckPoint = int(input('How many check points should be used ? '))

# Getting the true coordinates from a text file
Control = np.loadtxt('fidtext.txt')
x2 = Control[:, 1]
y2 = Control[:, 2]

if temp == 1: # Conformal
    # Defining the matrixes
    L = np.zeros([2*(nControlPoint), 1])
    A = np.zeros([2*(nControlPoint), 4])

    for i in range((nControlPoint)):
        L[2*i, :] = x2[i]
        L[2*i+1, :] = y2[i]

        A[2*i, :] = np.array([x1[i], y1[i], 1, 0])
        A[2*i+1, :] = np.array([y1[i], -x1[i], 0, 1])
    
    L_check = np.zeros([2*(nCheckPoint), 1])
    A_check = np.zeros([2*(nCheckPoint), 4])
    for i in range(0, nCheckPoint, 1):
        L_check[2*i, :] = x2[nControlPoint+i]
        L_check[2*i+1,:] = y2[nControlPoint+i]
        
        A_check[2*i,:] = np.array([x1[nControlPoint+i], y1[nControlPoint+i], 1, 0])
        A_check[2*i+1,:] = np.array([y1[nControlPoint+i], -x1[nControlPoint+i],0,1])
        

elif temp == 2: # Affine
    L = np.zeros([2*(nControlPoint), 1])
    A = np.zeros([2*(nControlPoint), 6])

    for i in range((nControlPoint)):
        L[2*i, :] = x2[i]
        L[2*i+1, :] = y2[i]
    
        A[2*i, :] = np.array([x1[i], y1[i], 1, 0, 0, 0])
        A[2*i+1, :] = np.array([0, 0, 0, y1[i], -x1[i], 1])
    
    L_check = np.zeros([2*(nCheckPoint), 1])
    A_check = np.zeros([2*(nCheckPoint), 6])

    for i in range((nCheckPoint)):
        L_check[2*i, :] = x2[nControlPoint+i]
        L_check[2*i+1, :] = y2[nControlPoint+i]
    
        A_check[2*i, :] = np.array([x1[nControlPoint+i], y1[nControlPoint+i], 1, 0, 0, 0])
        A_check[2*i+1, :] = np.array([0, 0, 0, y1[nControlPoint+i], -x1[nControlPoint+i], 1])
        
        
elif temp == 3: # Projective
    L = np.zeros([2*(nControlPoint), 1])
    A = np.zeros([2*(nControlPoint), 8])

    for i in range((nControlPoint)):
        L[2*i, :] = x2[i]
        L[2*i+1, :] = y2[i]
    
        A[2*i, :] = np.array([x1[i], y1[i], 1, 0, 0, 0, -x1[i]*x2[i], -y1[i]*x2[i]])
        A[2*i+1, :] = np.array([0, 0, 0, y1[i], x1[i], 1, -x1[i]*y2[i], -y1[i]*y2[i]])


    L_check = np.zeros([2*(nCheckPoint), 1])
    A_check = np.zeros([2*(nCheckPoint), 8])

    for i in range((nCheckPoint)):
        L_check[2*i, :] = x2[nControlPoint+i]
        L_check[2*i+1, :] = y2[nControlPoint+i]
    
        A_check[2*i, :] = np.array([x1[nControlPoint+i], y1[nControlPoint+i], 1, 0, 0, 0, -x1[nControlPoint+i]*x2[nControlPoint+i], -y1[nControlPoint+i]*x2[nControlPoint+i]])
        A_check[2*i+1, :] = np.array([0, 0, 0, y1[nControlPoint+i], x1[nControlPoint+i], 1, -x1[nControlPoint+i]*y2[nControlPoint+i], -y1[nControlPoint+i]*y2[nControlPoint+i]])


elif temp == 4: # Polynomial
    L = np.zeros([2*(nControlPoint), 1])
    A = np.zeros([2*(nControlPoint), 12])

    for i in range((nControlPoint)):
        L[2*i, :] = x2[i]
        L[2*i+1, :] = y2[i]
    
        A[2*i, :] = np.array([1, x1[i], y1[i], x1[i]**2, y1[i]**2, x1[i]*y1[i], 0, 0, 0, 0, 0, 0])
        A[2*i+1, :] = np.array([0, 0, 0, 0, 0, 0, 1, x1[i], y1[i], x1[i]**2, y1[i]**2, x1[i]*y1[i]])

    
    L_check = np.zeros([2*(nCheckPoint), 1])
    A_check = np.zeros([2*(nCheckPoint), 12])

    for i in range((nCheckPoint)):
        L_check[2*i, :] = x2[nControlPoint+i]
        L_check[2*i+1, :] = y2[nControlPoint+i]
    
        A_check[2*i, :] = np.array([1, x1[nControlPoint+i], y1[nControlPoint+i], x1[nControlPoint+i]**2, y1[nControlPoint+i]**2, x1[nControlPoint+i]*y1[nControlPoint+i], 0, 0, 0, 0, 0, 0])
        A_check[2*i+1, :] = np.array([0, 0, 0, 0, 0, 0, 1, x1[nControlPoint+i], y1[nControlPoint+i], x1[nControlPoint+i]**2, y1[nControlPoint+i]**2, x1[nControlPoint+i]*y1[nControlPoint+i]])



N = np.linalg.inv(np.matmul(np.transpose(A), A))
U = np.matmul(np.transpose(A), L)
X = np.matmul(N, U)
v = np.matmul(A , X) - L

print('\ntransformation parameters are :')
print(X)

# Using check points to calculate RMSE
v_Check = np.matmul(A_check, X)- L_check
rmse = np.sqrt(np.matmul(np.transpose(v), v) / nCheckPoint)
print('\n RMSE = ' + str(rmse))


if temp == 1:
    transformationName = "conformal"
elif temp == 2:
    transformationName = "affine"
elif temp == 3:
    transformationName = "projective"
elif temp == 4:
    transformationName = "polynomial"

with open('Output.txt', 'w') as f:
    f.write("We have used " + transformationName +" transformation method in this case. \n")
    f.write("number of control points : " + str(nControlPoint))
    f.write("\nnumber of check points : " + str(nCheckPoint))

    f.write("\n\nThe transformation parameters(X) are :\n" + str(X))
    f.write("\n\nThe residuals(V) of control points are :\n" + str(v))
    f.write("\n\nThe residuals(V) of check points are :\n" + str(v_Check))
    f.write("\n\nRoot Mean Square Error (RMSE) = :"+ str(rmse))